# only for RF1
from mojo.roboFont import version
if version < "2.0":
    # sorting the extension menu on 10.13
    import AppKit

    mainMenu = AppKit.NSApp().mainMenu()
    extensionMenu = mainMenu.itemWithTitle_("Extensions")
    menuToOrder = extensionMenu.submenu()

    extensionsItems = []
    scriptItems = []

    updateMenuItem = None

    currentItems = extensionsItems

    def orderMenuItems(items):
        def sorter(item):
            return (item.title().replace("Open ", ""), item.isAlternate())
        return sorted(items, key=sorter)
    
    def orderMenu(menu):
        if menu is None:
            return
        items = menu.itemArray()
        menu.removeAllItems()
        for item in orderMenuItems(items):
            menu.addItem_(item)        
            orderMenu(item.submenu())

    for item in menuToOrder.itemArray():
        if item.isSeparatorItem():
            currentItems = scriptItems
            continue
        if item.title() == "Update Menu":
            updateMenuItem = item
            continue
    
        currentItems.append(item)

    extensionsItems = orderMenuItems(extensionsItems)
    scriptItems = orderMenuItems(scriptItems)

    for scriptItem in scriptItems:
        orderMenu(scriptItem.submenu())

    newItems = []
    newItems.extend(extensionsItems)
    if scriptItems:
        newItems.append(AppKit.NSMenuItem.separatorItem())
        newItems.extend(scriptItems)

    newItems.append(AppKit.NSMenuItem.separatorItem())
    newItems.append(updateMenuItem)

    menuToOrder.removeAllItems()
    for newItem in newItems:
        menuToOrder.addItem_(newItem)    